realWoodharvesterGui = {}

local realWoodharvesterGui_mt = Class(realWoodharvesterGui, ScreenElement)

function realWoodharvesterGui:new(target, custom_mt)
    local self = ScreenElement:new(target, realWoodharvesterGui_mt)
    self.returnScreenName = ""
    return self
end

function realWoodharvesterGui:onOpen()
    realWoodharvesterGui:superClass().onOpen(self)
	FocusManager:setFocus(self.backButton)
	if self.target ~= nil then
		self.realWoodharvesterGuiHeader.text = g_i18n:getText('GUI_RW_SETTINGS') .. ' (' .. self.target:rwGetFullName() .. ')'
	end
end
function realWoodharvesterGui:onClose()
    realWoodharvesterGui:superClass().onClose(self)
end
function realWoodharvesterGui:onClickBack()
    realWoodharvesterGui:superClass().onClickBack(self)
	--RealWoodHarvester:guiClosed()
end
function realWoodharvesterGui:onClickOk()
    realWoodharvesterGui:superClass().onClickOk(self)
	if self.cutStep:getText() == '' then
		--self.cutStep:setText(self.lastTextCutStep)
	end
	RealWoodHarvester:settingsFromGui(self.target, self.delimbAccuracy:getState(), self.woodChipsAmount:getState(), self.minCut:getText(), self.maxCut:getText(), self.lastTextCutStep, self.showhelp:getState() )
    self:onClickBack()
end
function realWoodharvesterGui:setTarget(target)
	self.target = target
end
function realWoodharvesterGui:onIngameMenuHelpTextChanged(element)
end
function realWoodharvesterGui:onCreateRwGuiHeader(element)
	self.realWoodharvesterGuiHeader = element
	element.text = g_i18n:getText('GUI_RW_SETTINGS')
end
function realWoodharvesterGui:onCreateRwGuiHeaderGlobal(element)
	element.text = g_i18n:getText('GUI_RW_GLOBAL')
end
function realWoodharvesterGui:onCreateRwGuiHeaderCurrent(element)
	element.text = g_i18n:getText('GUI_RW_CURRENT')
end
function realWoodharvesterGui:onCreateRwGuiHeaderMisc(element)
	element.text = g_i18n:getText('GUI_RW_MISC')
end
function realWoodharvesterGui:onCreateDelimbAccuracy(element)
    self.delimbAccuracy = element
	element.labelElement.text = g_i18n:getText('GUI_RW_DELIMB_ACCURACY')
	element.toolTipText = g_i18n:getText('GUI_RW_DELIMB_ACCURACY_TOOLTIP')
    local values = {}

	for i = 1, #RealWoodHarvester.delimbAccuraciesTexts, 1 do
       values[i] = RealWoodHarvester.delimbAccuraciesTexts[i]
    end
	
    element:setTexts(values)
end
function realWoodharvesterGui:setDelimbAccuracy(index)
    self.delimbAccuracy:setState(index, false)
end

function realWoodharvesterGui:onCreateWoodChipsAmount(element)
    self.woodChipsAmount = element
	element.labelElement.text = g_i18n:getText('GUI_RW_WOODCHIPS_AMOUNT')
	element.toolTipText = g_i18n:getText('GUI_RW_WOODCHIPS_AMOUNT_TOOLTIP')
    local values = {}

	for i = 1, #RealWoodHarvester.woodChipsAmountsTexts, 1 do
       values[i] = RealWoodHarvester.woodChipsAmountsTexts[i]
    end
	
    element:setTexts(values)
end
function realWoodharvesterGui:setWoodChipsAmount(index)
    self.woodChipsAmount:setState(index, false)
end

function realWoodharvesterGui:onCreateMinCut(element)
    self.minCut = element
	element.toolTipText = g_i18n:getText('GUI_RW_CUT_LENGTH_MIN_TOOLTIP')
end
function realWoodharvesterGui:setMinCut(index)
    self.minCut:setText(tostring(index))
end
function realWoodharvesterGui:onCreateMinCutTitle(element)
	element.text = g_i18n:getText('GUI_RW_CUT_LENGTH_MIN')
	element.toolTipText = g_i18n:getText('GUI_RW_CUT_LENGTH_MIN_TOOLTIP')
end

function realWoodharvesterGui:onCreateMaxCut(element)
    self.maxCut = element
end
function realWoodharvesterGui:setMaxCut(index)
    self.maxCut:setText(tostring(index))
end
function realWoodharvesterGui:onCreateMaxCutTitle(element)
	element.text = g_i18n:getText('GUI_RW_CUT_LENGTH_MAX')
	element.toolTipText = g_i18n:getText('GUI_RW_CUT_LENGTH_MAX_TOOLTIP')
end

function realWoodharvesterGui:onCreateCutStep(element)
    self.cutStep = element
	element.toolTipText = g_i18n:getText('GUI_RW_CUT_LENGTH_MIN_TOOLTIP')
end
function realWoodharvesterGui:setCutStep(index)
    self.cutStep:setText(tostring(index))
	self.lastTextCutStep = tostring(index)
end
function realWoodharvesterGui:onCreateCutStepTitle(element)
	element.text = g_i18n:getText('GUI_RW_CUT_LENGTH_STEP')
	element.toolTipText = g_i18n:getText('GUI_RW_CUT_LENGTH_MIN_TOOLTIP')
end
function realWoodharvesterGui:onCutStepTextChanged()
    local text = self.cutStep.text

    if text ~= self.lastTextCutStep then
        if text ~= "" then
			local newChar = text:sub(-1)
            if newChar == '.' or tonumber(newChar) ~= nil then
                self.lastTextCutStep = text
            else
                self.cutStep:setText(self.lastTextCutStep)
            end
		else
			--self.lastTextCutStep = ""
        end
    end
end

function realWoodharvesterGui:onCreateShowhelp(element)
    self.showhelp = element
	element.labelElement.text = g_i18n:getText('GUI_RW_SHOWHELP')
	element.toolTipText = g_i18n:getText('GUI_RW_SHOWHELP_TOOLTIP')
    local values = {}

	for i = 1, #RealWoodHarvester.booleansTexts, 1 do
       values[i] = RealWoodHarvester.booleansTexts[i]
    end
	
    element:setTexts(values)
end
function realWoodharvesterGui:setShowhelp(index)
    self.showhelp:setState(index, false)
end
function realWoodharvesterGui:onClickResetButton()
    RealWoodHarvester:settingsResetGui(self.target)
end