--
-- FS19 - Real Wood Harvester
-- @author:    	kenny456 (kenny456@seznam.cz)
-- @history:	v1.0.0.0 - 2021-01-05 - first release
--
source(Utils.getFilename("gui/rwGui.lua", g_currentModDirectory))
source(Utils.getFilename("realWoodHarvester.lua", g_currentModDirectory))

RealWoodHarvester_register = {}

function RealWoodHarvester_register:loadMap()
end
function RealWoodHarvester_register:register(name)
	if g_specializationManager:getSpecializationByName("RealWoodHarvester") == nil then
		if RealWoodHarvester == nil then 
			print("ERROR: unable to add specialization 'RealWoodHarvester'")
		else 
			for i, typeDef in pairs(g_vehicleTypeManager.vehicleTypes) do
				if typeDef ~= nil and i ~= "locomotive" then 
					local isWoodHarvester  = false
					for name, spec in pairs(typeDef.specializationsByName) do
						if name == "woodHarvester"  then 
							isWoodHarvester = true 
						end 
					end
					if isWoodHarvester then
						typeDef.specializationsByName["RealWoodHarvester"] = RealWoodHarvester
						table.insert(typeDef.specializationNames, "RealWoodHarvester")
						table.insert(typeDef.specializations, RealWoodHarvester)  
					end 
				end 
			end   
		end 
	end
end
VehicleTypeManager.finalizeVehicleTypes = Utils.prependedFunction(VehicleTypeManager.finalizeVehicleTypes, RealWoodHarvester_register.register)
print("----RealWoodHarvester registered.")

addModEventListener(RealWoodHarvester_register)